;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                  Drugi program                    **
;**                  wariant czwarty                  **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
	.nolist
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
;-----------------------------------------------------------------------------
.def acc		=	r16
;-----------------------------------------------------------------------------
.equ	KeyPort		=	PORTA
.equ	LEDPort		=	PORTB
.equ	Key0Pin		=	0
.equ	Key1Pin		=	1
.equ	LEDPin		=	0
;-----------------------------------------------------------------------------
.equ	KeyPDirection	=	KeyPort - 1
.equ	LedPDirection	=	LEDPort - 1
.equ	KeyPins		=	KeyPort - 2
;-----------------------------------------------------------------------------
	.cseg
	.org	0				;
	rjmp	ResetProcessor			;
;-----------------------------------------------------------------------------
	.org	INT0addr			;External Interrupt0 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	INT1addr			;External Interrupt1 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	ICP1addr			;Input Capture1 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC1Aaddr			;Output Compare1A Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC1Baddr			;Output Compare1B Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OVF1addr			;Overflow1 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OVF0addr			;Overflow0 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	SPIaddr				;SPI Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	URXCaddr			;USART Receive Complete Int. Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	UDREaddr			;USART Data Register Empty Int. Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	UTXCaddr			;USART Transmit Complete Int. Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	ACIaddr				;Analog Comparator Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	INT2addr			;External Interrupt2 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC0addr				;Output Compare0 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	ERDYaddr			;EEPROM Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	SPMaddr				;SPM complete Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
ResetProcessor	:				;
	cli					;
	ldi	acc,LOW(RAMEND)			;
	out	SPL,acc				;
	ldi	acc,HIGH(RAMEND)		;
	out	SPH,acc				;
	cbi	KeyPDirection,Key0Pin		; Key0Pin - jako wejscia z PULL=UP
	sbi	KeyPort,Key0Pin			;
	cbi	KeyPDirection,Key1Pin		; Key1Pin - jako wejscia z PULL=UP
	sbi	KeyPort,Key1Pin			;
	sbi	LedPDirection,LEDPin		; LEDPin - jako wyjscie
	sbi	LEDPort,LEDPin			; LEDPin - wyjscie w stanie wysokim
Main_0	:					; poczatek petli
	in	acc,KeyPins			;  acc = stan portu KeyPort
	sbrs	acc,Key0Pin			;  czy jest wyzerowany pin Key0Pin w acc
	rjmp	Main_1				;  jezeli tak to skok do Main_1
	sbrs	acc,Key1Pin			;  czy jest wyzerowany pin Key1Pin w acc
	rjmp	Main_2				;  jeeli tak to skok do Main_2
	rjmp	Main_0				;  powrot do petli
Main_1	:					;
	cbi	LEDPort,LEDPin			;  LEDPin = 0 ==> LED swieci
	rjmp	Main_0				;
Main_2	:					;
	sbi	LEDPort,LEDPin			;  LEDPin = 1 ==> LED nie swieci
	rjmp	Main_0				;
						; koniec petli
;-----------------------------------------------------------------------------
.exit
