;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                                                   **
;**       Prezentacje i ilustracje algorytmow         **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
	.listmac
;-----------------------------------------------------------------------------
.macro	ldz
	ldi	zl,low(@0)
	ldi	zh,high(@0)
.endm
;-----------------------------------------------------------------------------
.def acc		= r16
.def acc2		= r17
.def param		= r18
;-----------------------------------------------------------------------------
		.dseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  DATA  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
;-----------------------------------------------------------------------------
		.cseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  CODE  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
	.org	0				;
	rjmp	ResetProcessor			;
;-----------------------------------------------------------------------------
.def	ARGL	= r2
.def	ARGM 	= r3
.def	ARGH	= r4
;-----------------------------------------------------------------------------
Mult10:				;PROCEDURE Mult10 ;
;******				;	dane do procedury umieci w rejestrach
				;	ARGM i ARGL
				;	wynik jest w  rejestrach
				;	ARGH:ARGM:ARGL
				;	ARGH:ARGM:ARGL := 10 * ARGM:ARGL ;
				;BEGIN (* Mult10 *)
	clr	ARGH		; wstpne zerowanie najstarszej czci wyniku
	lsl	ARGL		; po przesuniciu we wskaniku C bdzie bit 7,
				; ktry ma by umieszczony jako bit 0 w
				; starszej czci
	rol	ARGM		; przesunicie kolejnej czci
	rol	ARGH		; przesunicie kolejnej czci
				; w efekcie trjka rejestrw ARGH:ARGM:ARGL
				; zawiera wejciow liczb pomnoon przez 2
	push	ARGH		; zachowanie zawartoci rejestrw
				; ARGH:ARGM:ARGL
	push	ARGM		; do pniejszego wykorzystania
	push	ARGL		;
	lsl	ARGL		; trjka rejestrw ARGH:ARGM:ARGL zawiera
	rol	ARGM		; liczb wejciow pomnoon przez 4
	rol	ARGH		;
	lsl	ARGL		; trjka rejestrw ARGH:ARGM:ARGL zawiera
	rol	ARGM		; liczb wejciow pomnoon przez 8
	rol	ARGH		;
	pop	acc		; dodanie zachowanej wczeniej liczby
	add	ARGL,acc	; (zawierajcej argument pomnoony przez 2)
	pop	acc		;
	adc	ARGM,acc	;
	pop	acc		;
	adc	ARGH,acc	;
				;  w wyniku ARGH:ARGM:ARGL zawiera liczb
				;  pomnoon przez 10
	ret			;END (* Mult10 *) ;
;-----------------------------------------------------------------------------
Mult10U2:			;PROCEDURE Mult10U2;
;********			;	dane do procedury umieci w rejestrach
				;	ARGM i ARGL
				;	wynik jest w  rejestrach
				;	ARGH:ARGM:ARGL
				;	ARGH:ARGM:ARGL := 10 * ARGM:ARGL ;
				;BEGIN (* Mult10U2 *)
	clr	ARGH		; wstpne wyzerowanie rejestru wynikowego
	lsl	ARGL		; po przesuniciu we wskaniku C bdzie bit 7,
				; ktry ma by umieszczony jako bit 0 w
				; starszej czci
	rol	ARGM		; przesunicie kolejnej czci
	brcc	Mul10_0		; w wyniku przesunicia we wskaniku C jest
				; zawarty najstarszy bit wejciowej liczy,
				; ktry jest bitem znaku
				; jeeli bit ten jest ustawiony, to rejestr
				; najstarszej czci wyniku musi zawiera same
				; jedynki, w przeciwnym wypadku ma zawiera
				; zero (brcc przeskoczy instrukcj com)
	com	ARGH		; operacja negacji wszystkich bitw rejestru,
				; ktry na pocztku procedury by wyzerowany
				; pozwala uzyska same jedynki
Mul10_0:			; w efekcie trjka rejestrw ARGH:ARGM:ARGL
				; zawiera wejciow liczb pomnoon przez 2
				; dla liczb ze znakiem
	push	ARGH		; zachowanie zawartoci rejestrw
				; ARGH:ARGM:ARGL
	push	ARGM		; do pniejszego wykorzystania
	push	ARGL		;
	lsl	ARGL		; trjka rejestrw ARGH:ARGM:ARGL zawiera
	rol	ARGM		; liczb wejciow pomnoon przez 4
	rol	ARGH		;
	lsl	ARGL		; trjka rejestrw ARGH:ARGM:ARGL zawiera
	rol	ARGM		; liczb wejciow pomnoon przez 8
	rol	ARGH		;
	pop	acc		; dodanie zachowanej wczeniej liczby
	add	ARGL,acc	; (zawierajcej argument pomnoony przez 2)
	pop	acc		;
	adc	ARGM,acc	;
	pop	acc		;
	adc	ARGH,acc	;
				;  w wyniku ARGH:ARGM:ARGL zawiera liczb
				;  pomnoon przez 10
	ret			;END (* Mult10U2 *) ;
;-----------------------------------------------------------------------------
ClearRAM :					;PROCEDURE ClearRAM ;
;*********					;BEGIN (* ClearRAM *)
	ldz	RAMEND-1			; Z := ADR ( RAMEND ) - 1 ;
	clr	acc				;
CleRA_0	:					; LOOP
	st	-z,acc				;  Z := Z - 1 ;
						;  Z ^ := 0 ;
	cpi	zh,0				;  IF Z = 0x60 THEN
	brne	CleRA_2				;
	cpi	zl,0x60				;
	brne	CleRA_2				;
	rjmp	CleRA_1				;   EXIT ;
CleRA_2	:					;  END (* IF *) ;
	rjmp	CleRA_0				;
CleRA_1	:					; END (* LOOP *) ;
	ret					;EBD (* ClearRAM *) ;
;-----------------------------------------------------------------------------
ClearRegs :					;PROCEDURE ClearRegs ;
;**********					;BEGIN (* ClearRegs *)
	clr	R0				;
	ldz	0x1D				;
ClrR_0	:					;
	st	Z,R0				;
	subi	zl,0x01				;
	sbci	zh,0x00				;
	brne	ClrR_0				;
	ret					;END (* ClearRegs *) ;
;-----------------------------------------------------------------------------
ResetProcessor	:				;
	ldi	acc,HIGH(RAMEND)		;
	out	SPH,acc				;
	ldi	acc,LOW(RAMEND)			;
	out	SPL,acc				;
						;BEGIN (* Main *)
	rcall	ClearRAM			; ClearRAM ( ) ;
	rcall	ClearRegs			; ClearRegs ( ) ;
;*******
	ldi	acc , 0x12			; utworzenie parametrw wywoania
	mov	ARGM , acc			;
	ldi	acc , 0x34			;
	mov	ARGL , acc			; ARG = 1234 hex = 4660 dec
	rcall	Mult10				; wywoanie procedury (mnoenie bez
						; znaku) w wyniku dziaania procedury w
						; trjce rejestrw :
						; ARGH:ARGM:ARGL = 00B608 hex = 46600 dec
;*******
	ldi	acc , 0xFF			; utworzenie parametrw wywoania
	mov	ARGM , acc			;
	ldi	acc , 0xFF			;
	mov	ARGL , acc			; ARG = FFFF hex = 65535 dec
	rcall	Mult10				; wywoanie procedury (mnoenie bez
						; znaku) w wyniku dziaania procedury w
						; trjce rejestrw:
						; ARGH:ARGM:ARGL =09FFF6 hex =655350 dec
;*******
	ldi	acc , 0xFF			; utworzenie parametrw wywoania
	mov	ARGM , acc			;
	ldi	acc , 0xFF			;
	mov	ARGL , acc			; ARG = FFFF hex = -1 dec (U2)
	rcall	Mult10U2			; wywoanie procedury (mnoenie ze
						; znakiem) w wyniku dziaania procedury w
						; trjce rejestrw:
						; ARGH:ARGM:ARGL =FFFFF6 hex
						;                =-10 dec (U2)
halt:	rjmp	halt				;
						;END Main ;
;-----------------------------------------------------------------------------
.exit
