;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                                                   **
;**       Prezentacje i ilustracje algorytmow         **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
	.listmac
;-----------------------------------------------------------------------------
.macro	ldz
	ldi	zl,low(@0)
	ldi	zh,high(@0)
.endm
;-----------------------------------------------------------------------------
.def acc		= r16
.def acc2		= r17
.def param		= r18
;-----------------------------------------------------------------------------
		.dseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  DATA  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
;-----------------------------------------------------------------------------
		.cseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  CODE  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
	.org	0				;
	rjmp	ResetProcessor			;
;-----------------------------------------------------------------------------
.def DivLoopCounter	= r1
.def Argument1LL	= r2
.def Argument1LH	= r3
.def Argument1HL	= r4
.def Argument1HH	= r5
.def Argument2LL	= r6
.def Argument2LH	= r7
.def Argument2HL	= r8
.def Argument2HH	= r9
.def WorkRegLL		= r10
.def WorkRegLH		= r11
.def WorkRegHL		= r12
.def WorkRegHH		= r13
.def ResultLL		= r22
.def ResultLH		= r23
.def ResultHL		= r24
.def ResultHH		= r25
;-----------------------------------------------------------------------------
DivideArg1ByArg2Fract :			;
;					; Result := Argument1 DIV Argument2 ;
;					;		32 bit / 16 bit
;                             		; WorkReg := Argument1 MOD Argument2 ;
	mov	acc,Argument2LL		;
	or	acc,Argument2LH		;
	breq	DivFra_1		;
	clr	acc			;
	mov	ResultLL,acc		;
	mov	ResultLH,acc		;
	mov	ResultHL,acc		;
	mov	ResultHH,acc		;
	mov	WorkRegLL,acc		;
	mov	WorkRegLH,acc		;
	mov	WorkRegHL,acc		;
	mov	WorkRegHH,acc		;
	ldi	acc,32			;
	mov	DivLoopCounter,acc	;
DivFra_0 :				;
	lsl	Argument1LL		;
	rol	Argument1LH		;
	rol	Argument1HL		;
	rol	Argument1HH		;
	rol	WorkRegLL		;
	rol	WorkRegLH		;
	brcs	DivFra_2		;
	cp	WorkRegLL,Argument2LL	;
	cpc	WorkRegLH,Argument2LH	;
	brcs	DivFra_3		;
DivFra_2 :				;
	sec				;
	rol	ResultLL		;
	rol	ResultLH		;
	rol	ResultHL		;
	rol	ResultHH		;
	sub	WorkRegLL,Argument2LL	;
	sbc	WorkRegLH,Argument2LH	;
	rjmp	DivFra_4		;
DivFra_3 :				;
	lsl	ResultLL		;
	rol	ResultLH		;
	rol	ResultHL		;
	rol	ResultHH		;
DivFra_4 :				;
	dec	DivLoopCounter		;
	brne	DivFra_0		;
	clv				;
	ret				;
DivFra_1 :				;
	ldi	acc,0xFF		;
	mov	ResultLL,acc		;
	mov	ResultLH,acc		;
	mov	ResultHL,acc		;
	mov	ResultHH,acc		;
	ldi	acc,0			;
	mov	WorkRegLL,acc		;
	mov	WorkRegLH,acc		;
	mov	WorkRegHL,acc		;
	mov	WorkRegHH,acc		;
	sev				;
	ret				;
;-----------------------------------------------------------------------------
DivideArg1ByArg2Round :			;
;					; Result := Argument1 DIV Argument2 ;
;					;	  32 bit / 16 bit
	mov	acc,Argument2LL		;
	or	acc,Argument2LH		;
	breq	DivRound_1		;
	clr	acc			;
	mov	ResultLL,acc		;
	mov	ResultLH,acc		;
	mov	ResultHL,acc		;
	mov	ResultHH,acc		;
	mov	WorkRegLL,acc		;
	mov	WorkRegLH,acc		;
	mov	WorkRegHL,acc		;
	mov	WorkRegHH,acc		;
	ldi	acc,32			;
	mov	DivLoopCounter,acc	;
DivRound_0 :				;
	lsl	Argument1LL		;
	rol	Argument1LH		;
	rol	Argument1HL		;
	rol	Argument1HH		;
	rol	WorkRegLL		;
	rol	WorkRegLH		;
	brcs	DivRound_2		;
	cp	WorkRegLL,Argument2LL	;
	cpc	WorkRegLH,Argument2LH	;
	brcs	DivRound_3		;
DivRound_2 :				;
	sec				;
	rol	ResultLL		;
	rol	ResultLH		;
	rol	ResultHL		;
	rol	ResultHH		;
	sub	WorkRegLL,Argument2LL	;
	sbc	WorkRegLH,Argument2LH	;
	rjmp	DivRound_4		;
DivRound_3 :				;
	lsl	ResultLL		;
	rol	ResultLH		;
	rol	ResultHL		;
	rol	ResultHH		;
DivRound_4 : 				;
	dec	DivLoopCounter		;
	brne	DivRound_0		;
	lsl	WorkRegLL		;
	rol	WorkRegLH		;
	cp	WorkRegLL,Argument2LL	;
	cpc	WorkRegLH,Argument2LH	;
	brcs	DivRound_5		;
	ldi	acc,1			;
	add	ResultLL,acc		;
	ldi	acc,0			;
	adc	ResultLH,acc		;
	adc	ResultHL,acc		;
	adc	ResultHH,acc		;
DivRound_5 :				;
	clv				;
	ret				;
DivRound_1 :				;
	ldi	acc,0xFF		;
	mov	ResultLL,acc		;
	mov	ResultLH,acc		;
	mov	ResultHL,acc		;
	mov	ResultHH,acc		;
	ldi	acc,0			;
	mov	WorkRegLL,acc		;
	mov	WorkRegLH,acc		;
	mov	WorkRegHL,acc		;
	mov	WorkRegHH,acc		;
	sev				;
	ret				;
;-----------------------------------------------------------------------------
ClearRAM :				;PROCEDURE ClearRAM ;
;*********				;BEGIN (* ClearRAM *)
	ldz	RAMEND-1		; Z := ADR ( RAMEND ) - 1 ;
	clr	acc			;
CleRA_0	:				; LOOP
	st	-z,acc			;  Z := Z - 1 ;
					;  Z ^ := 0 ;
	cpi	zh,0			;  IF Z = 0x60 THEN
	brne	CleRA_2			;
	cpi	zl,0x60			;
	brne	CleRA_2			;
	rjmp	CleRA_1			;   EXIT ;
CleRA_2	:				;  END (* IF *) ;
	rjmp	CleRA_0			;
CleRA_1	:				; END (* LOOP *) ;
	ret				;EBD (* ClearRAM *) ;
;-----------------------------------------------------------------------------
ClearRegs :				;PROCEDURE ClearRegs ;
;**********				;BEGIN (* ClearRegs *)
	clr	R0			;
	ldz	0x1D			;
ClrR_0	:				;
	st	Z,R0			;
	subi	zl,0x01			;
	sbci	zh,0x00			;
	brne	ClrR_0			;
	ret				;END (* ClearRegs *) ;
;-----------------------------------------------------------------------------
ResetProcessor	:			;
	ldi	acc,HIGH(RAMEND)	;
	out	SPH,acc			;
	ldi	acc,LOW(RAMEND)		;
	out	SPL,acc			;
					;BEGIN (* Main *)
	rcall	ClearRAM		; ClearRAM ( ) ;
	rcall	ClearRegs		; ClearRegs ( ) ;
;		Argument1 = 12345678 hex = 305419896 dec
;		Argument2 = FFFF hex = 65535 dec
	ldi	acc,0x12		;
	mov	Argument1HH,acc		;
	ldi	acc,0x34		;
	mov	Argument1HL,acc		;
	ldi	acc,0x56		;
	mov	Argument1LH,acc		;
	ldi	acc,0x78		;
	mov	Argument1LL,acc		; Argument1 = 12345678 hex
	ldi	acc,0xFF		;
	mov	Argument2LH,acc		;
	ldi	acc,0xFF		;
	mov	Argument2LL,acc		; Argumentu2 = FFFF hex
	rcall	DivideArg1ByArg2Round	;
	mov	acc,ResultHH		; acc = 00 hex
	mov	acc,ResultHL		; acc = 00 hex
	mov	acc,ResultLH		; acc = 12 hex
	mov	acc,ResultLL		; acc = 34 hex
					; wywoanie procedury dzielenia z
					; zaokrgleniem:
					; uzyskany wynik (rej. Result) jest nastpujcy:
					; 1234 hex = 4660 dec
					; (wynik zosta zaokrglony w d)
					; (przy dzieleniu z zaokrgleniem reszta
					; nie ma sensu).
;********
;		Argument1 = 12345678 hex = 305419896 dec
;		Argument2 = FFFF hex = 65535 dec
	ldi	acc,0x12		;
	mov	Argument1HH,acc		;
	ldi	acc,0x34		;
	mov	Argument1HL,acc		;
	ldi	acc,0x56		;
	mov	Argument1LH,acc		;
	ldi	acc,0x78		;
	mov	Argument1LL,acc		; Argument1 = 12345678 hex
	ldi	acc,0xFF		;
	mov	Argument2LH,acc		;
	ldi	acc,0xFF		;
	mov	Argument2LL,acc		; Argumentu2 = FFFF hex
	rcall	DivideArg1ByArg2Fract	;
	mov	acc,ResultHH		; acc = 00 hex
	mov	acc,ResultHL		; acc = 00 hex
	mov	acc,ResultLH		; acc = 12 hex
	mov	acc,ResultLL		; acc = 34 hex
	mov	acc,WorkRegLH		; acc = 68 hex
	mov	acc,WorkRegLL		; acc = AC hex
					; wywoanie procedury dzielenia z reszt:
					; uzyskany wynik (rej. Result) jest nastpujcy:
					; 1234 hex = 4660 dec
					; reszta z dzielenia jest w rejestrze WorkReg
					; reszta = 68AC hex = 26796 dec
					; wynik w sensie liczby uamkowej ma warto:
					; 4660.408881 (wida, e liczba powinna zosta
					; zaokrglona w d).
halt:	rjmp	halt			;
					;END Main ;
;-----------------------------------------------------------------------------
.exit
