;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                                                   **
;**       Prezentacje i ilustracje algorytmow         **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
;
;  UWAGA:
;  Symulacj programu naley wykona z wczon w symulatorze
;  zewntrzn pamici RAM (ze wzgldu, e potrzeby programu
;  wykraczaj poza zasoby wewntrznej pamici RAM).
;
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
	.listmac
;-----------------------------------------------------------------------------
.macro	ldz
	ldi	zl,low(@0)
	ldi	zh,high(@0)
.endm
;-----------------------------------------------------------------------------
.macro	_ldx
	ldi	xl,low(@0)
	ldi	xh,high(@0)
.endm
;-----------------------------------------------------------------------------
.def	acc	= r16
.def	acc2	= r17
.def	resl	= r18
.def	resh	= r19
;-----------------------------------------------------------------------------
	.dseg
	.org	0x8000
;*******************************************************
;*******************************************************
;**                                                   **
;**                  DATA  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
;-----------------------------------------------------------------------------
	.cseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  CODE  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
	.org	0				;
	rjmp	ResetProcessor			;
;-----------------------------------------------------------------------------
	.org	INT0addr			;External Interrupt0 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	INT1addr			;External Interrupt1 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	ICP1addr			;Input Capture1 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC1Aaddr			;Output Compare1A Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC1Baddr			;Output Compare1B Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OVF1addr			;Overflow1 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OVF0addr			;Overflow0 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	SPIaddr				;SPI Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	URXCaddr			;USART Receive Complete Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	UDREaddr			;USART Data Register Empty Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	UTXCaddr			;USART Transmit Complete Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	ACIaddr				;Analog Comparator Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
;						;TYPE
;						;  RecType = RECORD
;						;              Pole1  : BYTE ;		(* +0 *)
;						;              Pole2  : CHAR ;		(* +1 *)
;						;              Pole3  : WORD ;		(* +2 *)
;						;              Pole4  : BOOLEAN ;	(* +4 *)
;						;            END (* RECORD *) ;	(* cao 5 bajtw *)
;						;   (* celowo wielko rekordu nie jest dwjkowa *)
;						;VAR
;						;  R : ARRAY [ 0 .. 7 ] OF RecType ;
;						;  Inx2 : BYTE ;
;						;.
;						;.
;						;.
;						; R [ Inx2 ] . Pole4 := TRUE ;
.equ	RecT_Pole1	= 0			;
.equ	RecT_Pole2	= 1			;
.equ	RecT_Pole3	= 2			;
.equ	RecT_Pole4	= 4			;
	.dseg
						;VAR
Inx2:	.byte	1				; Inx2	: BYTE ;
R:	.byte	40				; R :ARRAY[0..7] OF RecType; (* 8*5 bajtw *)
	.cseg
Example9 :					; Inx2 := 1 ;
	ldi	acc,1				;
	sts	Inx2,acc			;
						; R [ Inx2 ] . Pole4 := TRUE ;
	ldi	zl , low ( R )			; rejestr Z bdzie zawiera
						; adres zmiennej R
	ldi	zh , high ( R )			; jako adres pocztku obszaru R
	lds	acc , Inx2			; pobranie zawartoci zmiennej Inx2
	mov	acc2 , acc			; kopia zmiennej Inx2 w rejestrze acc2
	lsl	acc				; pomnoenie przez 2
	lsl	acc				; pomnoenie przez 2
	add	acc , acc2			; acc zawiera 5 * Inx2
	add	zl , acc			; obliczenie adresu wybranego
	ldi	acc , 0				; (Inx2) elementu tablicy R
	adc	zh , acc			;
	ldi	acc , 1				; TRUE moe by reprezentowane przez sta 1
	std	z+RecT_Pole4 , acc		; zapis wyniku, mikrokontrolery AVR
						; maj moliwo adresowania poredniego ze
						; staym przesuniciem (warto przesunicia jest
						; limitowana do 63  RecT_Pole4 mieci
						; si w wymaganym przedziale)
	ret					;
;-----------------------------------------------------------------------------
	.dseg
Inx1:	.byte		1			; Inx1 : BYTE ;
WX1:	.byte		2			; WX1 : BYTE ;
WX2:	.byte		2			; WX2 : WORD ;
WX3:	.byte		2			; WX3 : WORD ;
WX4:	.byte		256			; WX4 : ARRAY [ 1 .. 128 ] OF WORD ;
	.cseg
Example8 :					;
	ldi	acc,127				; Inx1 := 127 ;
	sts	Inx1,acc			;
	ldi	zl,low(WX1)			; WX1 := 890 ;
	ldi	zh,high(WX1)			;
	ldi	acc,low(890)			;
	st	z+,acc				;
	ldi	acc,high(890)			;
	st	z,acc				;
	ldi	zl,low(WX2)			; WX2 := 567 ;
	ldi	zh,high(WX2)			;
	ldi	acc,low(567)			;
	st	z+,acc				;
	ldi	acc,high(567)			;
	st	z,acc				;
	ldi	zl,low(WX3)			; WX3 := 1234 ;
	ldi	zh,high(WX3)			;
	ldi	acc,low(1234)			;
	st	z+,acc				;
	ldi	acc,high(1234)			;
	st	z,acc				;
						; WX4 [ Inx1 ] := WX1 + 2 * WX2 + 3 * WX3 ;
	ldi	zl,low(WX1)			; pobranie do rejestru Z adresu
	ldi	zh,high(WX1)			; zmiennej WX1
	ld	resl,z+				; pobranie do resh:resl
	ld	resh,z				; zawartoci zmiennej WX1
	ldi	zl,low(WX2)			; pobranie do rejestru Z adresu
	ldi	zh,high(WX2)			; zmiennej WX2
	ld	acc,z+				; pobranie do acc2:acc
	ld	acc2,z				; zawartoci zmiennej WX2
	lsl	acc				; pomnoenie przez 2
	rol	acc2				;
	add	resl,acc			; dosumowanie do wyniku czci wyraenia
	adc	resh,acc2			;
	ldi	zl,low(WX3)			; pobranie do rejestru Z
	ldi	zh,high(WX3)			; adresu zmiennej WX3
	ld	acc,z+				; pobranie do acc2:acc
	ld	acc2,z				; zawartoci zmiennej WX3
	add	resl,acc			; dosumowanie do wyniku czci wyraenia
	adc	resh,acc2			;
	lsl	acc				; pomnoenie WX3 przez 2
	rol	acc2				;
	add	resl,acc			; dosumowanie do wyniku czci wyraenia
	adc	resh,acc2			;
	lds	acc,Inx1			; pobranie zawartoci zmiennej Inx1
	dec	acc				; zmniejszenie wartosci indeksu o 1
						; (dolna granica indeksw tablicy)
	lsl	acc				; pomnoenie przez 2 (wielko elementu tablicy)
	ldi	zl,low(WX4)			; pobranie do rejestru Z adresu
	ldi	zh,high(WX4)			; zmiennej WX4
	add	zl,acc				; dosumowanie przesunicia adresowego
	ldi	acc,0				;
	adc	zh,acc				; rejestr Z wskazuje ma docelowe
						; miejsce w pamici
	st	z+,resl				; zapis we wskazane miejsce
	st	z,resh				; wyniku wyraenia
	ret					;
;-----------------------------------------------------------------------------
;						;VAR
;						;  X1 : BYTE ;
;						;  X2 : BYTE ;
;						;  X3 : BYTE ;
;						;  X5 : ARRAY [ 0 .. 255 ] OF BYTE ;
;						;  Inx1	: BYTE ;
;						;.
;						;.
;						;.
;						; X1 := 11 ;
;						; X2 := 22 ;
;						; X3 := 33 ;
;						; Inx1 := 177 ;
;						; X5 [ Inx1 ] := X1 + 2 * X2 + 3 * X3 ;
	.dseg
;Inx1:	.byte	1				; Inx1 : BYTE ;
X1:	.byte	1				; X1 : BYTE ;
X2:	.byte	1				; X2 : BYTE ;
X3:	.byte	1				; X3 : BYTE ;
X5:	.byte	256				; X5 : ARRAY [ 0 .. 255 ] OF BYTE ;
	.cseg
Example7 :					;
	ldi	acc , 11			; X1 := 11 ;
	sts	X1 , acc			;
	ldi	acc , 22			; X2 := 22 ;
	sts	X2 , acc			;
	ldi	acc , 33			; X3 := 33 ;
	sts	X3 , acc			;
	ldi	acc , 177			; Inx1 := 177 ;
	sts	Inx1 , acc			;
						; X5 [ Inx1 ] := X1 + 2 * X2 + 3 * X3 ;
	lds	acc2 , X1			; rejestr acc2 zawiera zawarto
						; zmiennej X1
	lds	acc , X2			; pobranie do acc zawartoci zmiennej X2
	lsl	acc				; pomnoenie przez 2
	add	acc2 , acc			; dosumowanie fragmentu wyraenia
	lds	acc , X3			; pobranie do acc zawartoci zmiennej X3
	add	acc2 , acc			; pomnoenie przez 3 bdzie
						; zrealizowane przez
						; 2 * X3 + X3 (czyli X3 ju moe by
						; dodane)
	lsl	acc				; pomnoenie przez 2 (2*X3)
	add	acc2 , acc			; acc2 zawiera kompletny wynik
	lds	acc , Inx1			; pobranie zawartoci zmiennej Inx1
	ldi	zl , low ( X5 )			; pobranie do rejestru Z adresu zmiennej
						; X5
	ldi	zh , high ( X5 )		;
	add	zl , acc			; dosumowanie do adresu przesunicia
						; wynikajcego z indeksowania
	ldi	acc , 0				;
	adc	zh , acc			; rejestr Z wskazuje na waciwe miejsce w
						; pamici
	st	z , acc2			; zapis wyniku wyraenia
	ret					;
;-----------------------------------------------------------------------------
;						;VAR
;						;  X1 : BYTE ;
;						;  X2 : BYTE ;
;						;  X3 : BYTE ;
;						;  X4 : BYTE ;
;						;.
;						;.
;						;.
;						; X1 := X4 - 2 * ( X2 + X3 ) ;
	.dseg
;X1:	.byte		1			; X1 : BYTE ;
;X2:	.byte		1			; X2 : BYTE ;
;X3:	.byte		1			; X3 : BYTE ;
X4:	.byte		1			; X4 : BYTE ;
	.cseg
Example6 :					;
	ldi	acc , 44			; X2 := 44 ;
	sts	X2 , acc			;
	ldi	acc , 23			; X3 := 23 ;
	sts	X3 , acc			;
	ldi	acc , 172			; X4 := 172 ;
	sts	X4 , acc			;
						; X1 := X4 - 2 * ( X2 + X3 ) ;
	lds	acc , X2			; obliczenie fragmentu wyraenia (X2+X3)
	lds	acc2 , X3			;
	add	acc , acc2			;
	lsl	acc				; 2*(X2+X3)
	lds	acc2 , X4			;
	sub	acc2 , acc			; acc2 zawiera wynik X4-2*(X2+X3)
	sts	X1 , acc2			;
	ret					;
;-----------------------------------------------------------------------------
;						;TYPE
;						;  Rekord   = RECORD
;						;                PoleA : BYTE ;
;						;                PoleB : BOOLEAN ;
;						;                PoleC : WORD ;
;						;                PoleD : ARRAY [0..7] OF CHAR ;
;						;                PoleE : ADDRESS ;
;						;              END (* RECORD *) ;
;						;VAR
;						;  Zmienna : Rekord ;
;						;  Inx1 : BYTE ;
;						;.
;						;.
;						;.
;						; Inx1 := 6 ;
;						; Zmienna . PoleC := 1777 ;
;						; Zmienna . PoleD [ Inx1 ]  := 'Q' ;
.equ	Rekord_PoleA	= 0 	;
.equ	Rekord_PoleB	= 1	;
.equ	Rekord_PoleC	= 2	;
.equ	Rekord_PoleD	= 4	;
.equ	Rekord_PoleE	= 12	;
	.dseg
Zmienna:	.byte		14		; Zmienna : Rekord ;
;Inx1:		.byte		1		; Inx1 : BYTE ;
	.cseg
Example5 :					;
						; Inx1 := 6 ;
	ldi	acc , 6				; warto do wpisania
	sts	Inx1 , acc			; wpis do pamici
						; Zmienna . PoleC := 1777 ;
	ldi	zl,low(Zmienna+Rekord_PoleC)	; pobranie do rejestru zl modszej
						; czci docelowego adresu zmiennej
						; (wynik jest wyliczalny przez
						; kompilator  staa  Rekord_PoleC ma
						; znan warto)
	ldi	zh,high(Zmienna+Rekord_PoleC)	; pobranie do rejestru zl starszej
						; czci docelowego adresu zmiennej
	ldi	acc,low(1777)			; wydzielenie modszej czci wyniku
	st	z + , acc			; zapis wyniku w pamici
	ldi	acc,high(1777)			; wydzielenie starszej czci wyniku
	st	z , acc				; zapis wyniku w pamici
						; Zmienna . PoleD [ Inx1 ]  := 'Q' ;
	lds	acc , Inx1			; pobranie wartoci zmiennej
						; acc zawiera przesunici adresowe
						; wynikajce z indeksowania (o ile
						; dalej od pocztku Zmienna.PoleD jest
						; miejsce docelowe na wynik)
	ldi	acc2 , Rekord_PoleD		;
	add	acc , acc2			; acc zawiera przesunici adresowe
						; wynikajce z indeksowania i
						; pooenia pola w obrbie rekordu
						; (o ile dalej od pocztku Zmienna
						; jest miejsce docelowe na wynik)
	ldi	zl,low(Zmienna)			; pobranie adresu pocztku zmiennej
	ldi	zh,high(Zmienna)		;
	add	zl , acc			; dodanie do adresu pocztku
	ldi	acc , 0				; zmiennej obliczonego wczeniej
	adc	zh , acc			; przesunicia (z zawiera finalny
						; adres)
	ldi	acc , 'Q'			; pobranie wyniku
	st	z , acc				; zapisanie wyniku do pamici
;*******
;						; Zmienna . PoleA := 5 ;
;						; Zmienna . PoleB := TRUE ;
;						; Zmienna . PoleC := 1234 ;
;						; Zmienna . PoleD [ Inx1 ]  := 'X' ;
						; Zmienna . PoleA := 5 ;
	ldi	zl,low(Zmienna)			; pobranie do rejestru zl
						; modszej czci podstawy
						; adresowej (pocztku
						; obszaru rekordu)
	ldi	zh,high(Zmienna)		; pobranie do rejestru zh
						; starszej czci
						; podstawy adresowej
	ldi	acc , 5				; warto do wpisania
	std	z+Rekord_PoleA,acc		; zapis wyniku do pamici
						; (rzeczywisty adres w pamici
						; wyliczony jest poprzez
						; zsumowanie zawartoci rejestru
						; adresowego Z i przesunicia
						; wzgldnego  Rekord_PoleA
						; Zmienna . PoleB := TRUE ;
	ldi	acc , 1				; staa TRUE
	std	z+Rekord_PoleB,acc		; analogicznie jak wyej
						; Zmienna . PoleC := 1234 ;
	ldi	acc , low ( 1234 )		;
	std	z+Rekord_PoleC,acc		;
	ldi	acc , high ( 1234 )		;
	std	z+Rekord_PoleC+1,acc		; zwrmy uwag, e wyraenie
						; przesunicia adresowego wynosi
						; 'Rekord_PoleC + 1' (jest
						; ono policzalne na etapie
						; kompilacji i zadaniem
						; kompilatora jest okrelenie
						; finalnej wartoci
						; tego przesunicia)
						; Zmienna.PoleD [ Inx1 ]:='X' ;
	lds	acc , Inx1			; rzeczywisty adres w pamici
						; RAM, do ktrego
	add	zl , acc			; ma nastpi zapis wyraa si
						; nastpujc
	ldi	acc , 0				; zalenoci: adres 'Zmienna'
						; (zawarty w
	adc	zh , acc			; rejestrze Z) + przesunicie
						; wynikajce z
	ldi	acc , 'X'			; pooenia pola (staa
						; Rekord_PoleD) + 
	std	z+Rekord_PoleD,acc		; przesunicie wynikajce z
						; indeksowania
						; (zawarto rejestru acc). Adres
						; finalny jest sum wymienionych
						; trzech skadnikw, ale
						; zsumowanych w innej kolejnoci.
	ret					;
;-----------------------------------------------------------------------------
;						;VAR
;						;  Slowo : WORD ;
;						;  Pokaznik : POINTER TO WORD ;
;						;.
;						;.
;						;.
;						; Pokaznik := ADR ( Slowo ) ;
;						; Pokaznik ^ := 0x1234 ;
	.dseg
Slowo:		.byte	2			; Slowo	: WORD ;
Pokaznik: 	.byte	2			; Pokaznik : POINTER TO WORD ;
	.cseg
						; Pokaznik := ADR ( Slowo ) ;
Example4 :					;
	ldi	zl,low(Pokaznik)		; pobranie do rejestru z adresu
						; zmiennej Pokaznik
	ldi	zh,high(Pokaznik)		;
	ldi	acc , low ( Slowo )		; pobranie modszej czci adresu
						; zmiennej Slowo
	st	z + , acc			; zapis wartoci z automatyczn
						; zmian zawartoci rejestru z
						; o 1
	ldi	acc,high(Slowo)			; pobranie starszej czci adresu
						; zmiennej Slowo
	st	z , acc				; zapis wartoci
						; Pokaznik ^ := 0x1234 ;
	ldi	zl,low(Pokaznik)		; wpis do rejestru z adresu
						; zmiennej Pokaznik
	ldi	zh,high(Pokaznik)		;
	ld	xl , z +			; pobranie do rejestru x wartoci
						; zmiennej
	ld	xh , z				;
						; rejestr x teraz bdzie zawiera
						; adres docelowego miejsca w
						; pamici
	ldi	acc,low(0x1234)			; pobranie modszej czci
	st	x + , acc			; wpis do pamici modszej czci
	ldi	acc,high(0x1234)		; pobranie starszej czci
	st	x , acc				; wpis do pamici starszej czci
	ret					;
;-----------------------------------------------------------------------------
;						;VAR
;						;  Table : ARRAY [ 0 .. 31 ] OF WORD ;
;						;  Inx : WORD ;
;						;.
;						;.
;						;.
;						;  Inx := 27 ;
;						;  Table [ Inx ] := Inx + 231 ;
	.dseg
Table:	.byte	64				; Table : ARRAY [ 0 .. 31 ] OF WORD ;
Inx:	.byte	2				; Inx : WORD ;
	.cseg
Example3 :					;
						;  Inx := 27 ;
	ldi	zl,low(Inx)			; wpis do rejestru Z adresu
						; zmiennej Inx
	ldi	zh,high(Inx)			;
	ldi	acc,low(27)			; wpis do akumulatora staej 27
						; (modsza cz staej 27)
	st	z + , acc			; wpis do obszaru zmiennej
						; modszej czci
						; ze zwikszeniem wskanika Z o 1
	ldi	acc,high(27)			; wpis do akumulatora staej 0
						;(starsza cz staej 27)
	st	z , acc				; wpis do obszaru zmiennej
						; starszej czci
						; Table [ Inx ] := Inx + 3 ;
	ldi	zl,low(Inx)			; wpis do rejestru Z adresu
						; zmiennej Inx
	ldi	zh,high(Inx)			;
	ld	xl,z+				; pobranie modszej czci
						; zmiennej Inx
	ld	xh , z				; pobranie starszej czci
						; zmiennej Inx rejestr X zawiera
						; zawarto zmiennej Inx
	ldi	zl,low(Table)			; wpis do rejestru Z adresu
						; zmiennej Table
	ldi	zh,high(Table)			;
	add	zl , xl				; obliczenie pooenia w pamici
						; zmiennej
	adc	zh , xh				; do adresu zmiennej Table trzeba
						; doda 
	add	zl , xl				; warto zmiennej Inx pomnoonej
						; przez 2 (2-wielko jednego
						; elementu tablicy,
						; zrealizowane poprzez dwukrotne
						; dodanie)
	adc	zh , xh				; Table [ Inx ] - adres zawarty
						; jest z rejestrze z
	ldi	acc,low(231)			; obliczenie wartoci wyraenia
						; Inx + 231
	add	xl , acc			; rejestr X nadal zawiera warto
	ldi	acc,high(231)			; zmiennej Inx
	adc	xh , acc			;
	st	z + , xl			; wpis do obszaru zmiennej
						; modszej czci
						; ze zwikszeniem wskanika Z o 1
	st	z , xh				; wpis do obszaru zmiennej
						; starszej czci
	ret					;					
;-----------------------------------------------------------------------------
;						;VAR
;						;  Table : ARRAY [ 0 .. 31 ] OF BYTE ;
;						;  Table2 : ARRAY [ 1 .. 8 ] OF WORD ;
;						;  Inx : BYTE ;
;						;.
;						;.
;						;.
;						; Table [ 19 ] := 192 ;
;						; Table2 [ 3 ] := 2004 ;
;						; Inx := 27 ;
;						; Table [ Inx ] := 1 ;
	.dseg
;Table:	.byte	32				; Table : ARRAY [ 0 .. 31 ] OF BYTE ;
Table2:.byte	16				; Table2 : ARRAY [ 1 .. 8 ] OF WORD ;
;Inx:	.byte	1				; Inx : BYTE ;
	.cseg
Example2 :					;
	ldi	acc , 192			; Table [ 19 ] := 192 ;
	sts	Table+19,acc			; kompilator jest w stanie wygenerowa
						; tak instrukcj
						; (pooenie w pamici elementu
						; zmiennej Table[19] jest
						; wyliczalne na etapie kompilacji)
						; w oglnym przypadku zagadnienie jest
						; bardziej zoone, w tym przypadku
						; tablica Table jest
						; indeksowana od zera oraz wielko
						; elementu tablicy wynosi 1 bajt
						; Table2 [ 3 ] := 2004 ;
	ldi	zl,low(Table2+4)		; bo: 4=2*(31)
	ldi	zh,high(Table2+4)		;
						; pobranie do rejestru Z (oddzielnie
						; zl i zh) docelowego
						; adresu zmiennej w pamici jako sum
						; adresu pocztku
						; obszaru tablicy Table2 i wzgldnego
						; przesunicia w obrbie tablicy,
						; 2 * ( 3  1 ) = <wielko elementu tablicy> *
						; ( <indeks> - <dolna granica indeksw> )
						; warto wyraenia jest moliwa do
						; wyliczenia przez kompilator
	ldi	acc , low ( 2004 )		;
	st	z + , acc			; zapis modszej czci z jednoczesnym
						; zwikszeniem zawartoci rejestru
						; adresowego Z o jeden
	ldi	acc , high ( 2004 )		;
	st	z , acc				; zapis starszej czci
	ldi	acc , 27			; Inx := 27 ;
	sts	Inx , acc			;
						; Table [ Inx ] := 1 ;
						; w tym przypadku niestety w programie
						; naley zawrze instrukcje
						; pozwalajce na okrelenie pooenia
						; zmiennej Table[Inx] (adres zaley od
						; zawartoci zmiennej Inx)
	lds	acc , Inx			; pobranie do akumulatora zawartoci
						; zmiennej Inx
	ldi	zl , low ( Table )		;
						; pobranie do rejestru Z adresu
						; zmiennej Table
	ldi	zh , high ( Table )		;
	add	zl , acc			; dodanie do adresu zawartego w Z
						; wartoci indeksu
	ldi	acc , 0				;
	adc	zh , acc			; rejestr Z zawiera adres zmiennej
						; Table[Inx]
	ldi	acc , 1				; warto do wpisanie do tablicy
	st	z , acc				; zapisanie wyniku pod adres
						; okrelony w Z
	ret					;
;-----------------------------------------------------------------------------
;						;CONST
;						;  MaxInx = 214 ;
;						;VAR
;						;  Index : BYTE ;
;						;  Znak : CHAR ;
;						;.
;						;.
;						;.
;						; Index := MaxInx ;
;						; Znak := G ;
.equ	MaxInx	= 214 				;
	.dseg
Index:	.byte	1				; Index : BYTE ;
Znak:	.byte	1				; Znak : CHAR ;
	.cseg
Example1 :					;
	ldi	acc , MaxInx			; Index := MaxInx ;
	sts	Index , acc			; Proste adresowanie
						; jednobajtowej zmiennej
	ldi	acc , 'G'			; Znak := 'G' ;
	sts	Znak ,acc			; Proste adresowanie jednobajtowej
						; zmiennej
	ret					;
;-----------------------------------------------------------------------------
ClearRAM :					;PROCEDURE ClearRAM ;
;*********					;BEGIN (* ClearRAM *)
	ldz	RAMEND-1			; Z := ADR ( RAMEND ) - 1 ;
	clr	acc				;
CleRA_0	:					; LOOP
	st	-z,acc				;  Z := Z - 1 ;
						;  Z ^ := 0 ;
	cpi	zh,0				;  IF Z = 0x60 THEN
	brne	CleRA_2				;
	cpi	zl,0x60				;
	brne	CleRA_2				;
	rjmp	CleRA_1				;   EXIT ;
CleRA_2	:					;  END (* IF *) ;
	rjmp	CleRA_0				;
CleRA_1	:					; END (* LOOP *) ;
	ret					;EBD (* ClearRAM *) ;
;-----------------------------------------------------------------------------
ClearRegs :					;PROCEDURE ClearRegs ;
;**********					;BEGIN (* ClearRegs *)
	clr	R0				;
	ldz	0x1D				;
ClrR_0	:					;
	st	Z,R0				;
	subi	zl,0x01				;
	sbci	zh,0x00				;
	brne	ClrR_0				;
	ret					;END (* ClearRegs *) ;
;-----------------------------------------------------------------------------
ResetProcessor	:				;
	ldi	acc,HIGH(RAMEND)		;
	out	SPH,acc				;
	ldi	acc,LOW(RAMEND)			;
	out	SPL,acc				;
						;BEGIN (* Main *)
	rcall	ClearRAM			; ClearRAM ( ) ;
	rcall	ClearRegs			; ClearRegs ( ) ;
;----------
	rcall	Example1			;
	rcall	Example2			;
	rcall	Example3			;
	rcall	Example4			;
	rcall	Example5			;
	rcall	Example6			;
	rcall	Example7			;
	rcall	Example8			;
	rcall	Example9			;
halt:	rjmp	halt				;END (* Main *)
;-----------------------------------------------------------------------------
.exit

