;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                                                   **
;**       Typowe i czesto uzywane procedury           **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
;
.message	"***>>> Dolaczenie bibioteki UTIL"
;-----------------------------------------------------------------------------
ClearRegs :					;PROCEDURE ClearRegs ;
;**********					;BEGIN (* ClearRegs *)
	clr	R0				;
	ldz	0x1D				;
ClrR_0	:					;
	st	Z,R0				;
	dec	zl				;
	brne	ClrR_0				;
	ret					;END (* ClearRegs *) ;
;-----------------------------------------------------------------------------
ClearRAM :					;PROCEDURE ClearRAM ;
;*********					;BEGIN (* ClearRAM *)
	ldz	RAMEND-1			; Z := ADR ( RAMEND ) - 1 ;
	clr	acc				;
CleRA_0	:					; LOOP
	st	-Z,acc				;  Z := Z - 1 ;
						;  Z ^ := 0 ;
	cpi	ZH,0				;  IF Z = 0x60 THEN
	brne	CleRA_2				;
	cpi	ZL,0x60				;
	brne	CleRA_2				;
	rjmp	CleRA_1				;   EXIT ;
CleRA_2	:					;  END (* IF *) ;
	rjmp	CleRA_0				;
CleRA_1	:					; END (* LOOP *) ;
	ret					;END ClearRAM ;
;-----------------------------------------------------------------------------
Delay	:					;PROCEDURE Delay ( ) ;
;********					;BEGIN (* Delay *)
	ldz	0				; Z := 0 ;
Del_0	:					; REPEAT
	adiw	zl,1				;  Z := Z + 1 ;
	mov	acc,ZL				; UNTIL Z = 0 ;
	or	acc,ZH				;
	brne	Del_0				;
	ret					;END (* Delay *) ;
;-----------------------------------------------------------------------------
LongDelay :					;PROCEDURE LongDelay ( ) ;
;**********					;BEGIN (* LongDelay *)
	ldi	acc,8				; FOR acc := 1 TO 8 DO
LoDel_0	:					;
	push	acc				;
	rcall	Delay				;  Delay ( ) ;
	pop	acc				;
	dec	acc				;
	brne	LoDel_0				; END (* FOR *) ;
	ret					;END (* LongDelay *) ;
;-----------------------------------------------------------------------------
.exit
